#version 330

in vec3 pos;
in vec3 unscaledNormal;

out vec3 fragPos;
out vec3 normal;

uniform mat4 model, view, projection;

void main() {
	normal = mat3(inverse(transpose(model))) * unscaledNormal;
	fragPos = vec3(model * vec4(pos, 1));
	gl_Position = projection * view * vec4(fragPos, 1);
}
